
#include "regular_expression.h"
#include "regexp_lexer.h"

using namespace std;
using namespace AlgorithMan;

namespace AlgorithMan
{

    namespace RegularExpressions
    {

        RegularExpression::RegularExpression()
        {
        }

        RegularExpression::~RegularExpression()
        {
        }



        Sum::Sum(RegularExpression* A, RegularExpression* B)
        {
            this->A = A;
            this->B = B;
        }

        Sum::~Sum()
        {
            delete A;
            delete B;
        }

        string Sum::UnixSyntax()
        {
            return string("(") + A->UnixSyntax() + ")|(" + B->UnixSyntax() + ")";
        }

        Automaton* Sum::ThompsonConstruction()
        {
            Automaton *A = A->ThompsonConstruction();
            Automaton *B = B->ThompsonConstruction();
        }



        Product::Product(RegularExpression* A, RegularExpression* B)
        {
            this->A = A;
            this->B = B;
        }

        Product::~Product()
        {
            delete A;
            delete B;
        }

        string Product::UnixSyntax()
        {
            return string("(") + A->UnixSyntax() + ")(" + B->UnixSyntax() + ")";
        }



        KleeneStar::KleeneStar(RegularExpression* A)
        {
            this->A = A;
        }

        KleeneStar::~KleeneStar()
        {
            delete A;
        }

        string KleeneStar::UnixSyntax()
        {
            return string("(") + A->UnixSyntax() + ")*";
        }



        FixedText::FixedText(string *str)
        {
            this->str = str;
        }

        FixedText::~FixedText()
        {
            delete str;
        }

        string FixedText::UnixSyntax()
        {
            string result;
            for(string::iterator i = str->begin(); i != str->end(); i++)
            {
                switch(*i)
                {
                    case '(' : result += "\\(";  break;
                    case ')' : result += "\\)";  break;
                    case '*' : result += "\\*";  break;
                    case '$' : result += "\\$";  break;
                    case '\\': result += "\\\\"; break;
                    case '^' : result += "\\^";  break;
                    case '|' : result += "\\|";  break;
                    case '+' : result += "\\+";  break;
                    default:   result += string(1,*i); break;
                }
            }
            return string("\"")+result+"\"";
        }



        #include "RegExpParser.hpp"



        RegularExpression* RegularExpression::Parse(istream& is)
        {
            RegExpLexer l(is);
            RegularExpression* result;
            RegExpParser p(l, &result);
            if(p.parse() == 0)
                return result;
            else
                return NULL;
        }



    } // namespace RegularExpressions

} // namespace AlgorithMan
